#include "TClass.h"
#include "TList.h"
#include "TStreamerInfo.h"
#include "TStreamerElement.h"
#include "TRealData.h"
#include "TBuffer.h"
#include "TError.h"

/*
typedef void (*MemberStreamerFunc_t)(TBuffer&, void*, Int_t); // Streamer function for a data member
*/


void TObjArrMemberStreamer(TBuffer &buf, void *addr, Int_t n) {

   void **start = (void**)addr;
   if (n < 1)
      n = 1;
   auto cl = TClass::GetClass("TObjArray_wrapper");
   for (Int_t j=0; j<n; j++) {
      void *old = start[j];
      start[j] = buf.ReadObjectAny(cl);
      if (old && old!=start[j] &&
          TStreamerInfo::CanDelete()) {
             ((TClass*)cl)->Destructor(old,kFALSE); // call delete and desctructor
      }
      TObjArray *arr = (TObjArray*)start[j];
   }

}

void streamer()
{
   auto cl = TClass::GetClass("WCSimRootEvent_v0");


   if (cl) {
      cl->BuildRealData();
      cl->SetMemberStreamer("*fEventList", TObjArrMemberStreamer);
   }

   cl = TClass::GetClass("WCSimRootEvent");
   if (cl) {
      cl->BuildRealData();
      cl->SetMemberStreamer("*fEventList", TObjArrMemberStreamer);
      cl->SetMemberStreamer("fEventList", TObjArrMemberStreamer);
      auto info = cl->GetStreamerInfo();
      Int_t offset;
      auto elem = info->GetStreamerElement("fEventList", offset);
      if (elem)
         elem->SetStreamer( cl->GetRealData("fEventList")->GetStreamer() );
      else
         Error("StreamerUpdater","Can not find the StreamerElement for fEventList in %s", cl->GetName());
      info->Clear("build");
      info->BuildOld();
   }
}
